#include <stdlib.h>

struct intlist {
    int dato;
    struct intlist *next;
};

typedef struct intlist intlist;

/* crea una lista vuota e ne restituisce il puntatore radice */
intlist *createlist(void);

/* visita una lista e esegue su ogni elemento la funzione op */
void traverse(intlist *p, void (*op)(intlist *));

/* stampa l'elemento puntato */
void printelem(struct intlist *q);

/* ritorna il numero di elementi nella lista */
int countlist(intlist *p);

/* inserisce un elemento in testa alla lista */
intlist *insert(intlist *p, int elem);

/* inserisce un elem nella lista prima del primo elemento >= di elem */ 
intlist *insertinorder(intlist *p, int elem);

/* cancella l'elemento puntato da q dalla lista */
intlist *delete(intlist *p, intlist *q);

/* distrugge la lista */
void destroylist(intlist *p);

/* concatena la lista con radice q alla lista con radice p */
intlist *listcat(intlist *p, intlist *q);

/* restituisce vero se la funzione check e' vera su almeno un elemento */
char traverseandcheck(intlist *p, char (*check)(intlist *, int), int a);

/* restituisce il primo elemento per cui check e' vera oppure NULL*/
intlist *getcheckelem(intlist *p, char(*check)(intlist *, int), int a);

/* restituisce vero se p->dato == elem */ 
char checkexist(intlist *p, int elem);

/* restituisce vero se l'elemento e' presente nella lista */
char existsinlist(intlist *p, int elem);

/* restituisce il primo elemento q per cui q->dato == elem */
intlist *geteleminlist(intlist *p, int elem);

/* ritorna il numero di elementi nella lista: versione ricorsiva */
int rcountlist(intlist *p);

/* visita una lista e esegue su ogni elemento la funzione op: versione ricorsiva */
void rtraverse(intlist *p, void (*op)(intlist *));

/* concatena la lista con radice q alla lista con radice p: versione ricorsiva */
intlist *rlistcat(intlist *p, intlist *q);


