#include <stdio.h>
#include "intstack.h"

intstack *createstack(void)
{
    intstack *st = malloc(sizeof(intstack));

    if(!st) {
        fprintf(stderr,"Errore di allocazione nella creazione dello stack\n");
        exit(-1);
    }
    st->top = createlist();
    st->count = 0;
    return st;
}

void destroystack(intstack *st)
{
	destroylist(st->top);
	free(st);
}

void push(intstack *st, int elem)
{
    insert(st->top, elem);
    st->count++;
}

int pop(intstack *st)
{
    int e;

    if(!st->count){
        fprintf(stderr,"Errore: pop su stack vuoto\n");
        exit(-2);
    };
    e = head(st->top);
    deletehead(st->top);
    st->count--;
    return e;
}

char empty(intstack *st)
{
    return !st->count;
}
