#include <stdio.h>
#include <stdlib.h>  /* per utilizzare malloc, calloc e free  e qsort*/
#include <string.h>  /* per utilizzare strlen, strcpy */

#define DIMWORD	80

/* prototipo di qsort: */
/* void qsort(void *base, size_t n, size_t, size, int (*)(const void *, const void *)) */

int comparelex(const void *a, const void *b)
{
	return strcmp(*(char **)a,*(char **)b);
}

int comparelen(const void *a, const void *b)
{
	return strlen(*(char **)a) - strlen(*(char **)b);
}

int lessthan(const void *a, const void *b)
{
	return(*(int *)a - *(int *)b);
}

int main(void)
{
	char **words;
	char w[DIMWORD+1];
	int i,n;
	int array[] = {5, 7, 9, 9, 3, 4, 3, 2, 1, 6};	

	scanf("%d",&n);
	if(!(words = calloc(n,sizeof(char *)))) {
		fprintf(stderr,"Errore di allocazione per l'array \"words\"\n");
		return -1;
	}
	for(i = 0; i < n;i++) {
		scanf("%s",w);
		if(!(words[i] = malloc(strlen(w)+1))) {
			fprintf(stderr,"Errore di allocazione per la parola \"%s\"\n",w);
			return -2;
		}
		strcpy(words[i],w);		
	}
	
	qsort(words,n,sizeof(char *),comparelex);
	
	printf("Elenco delle parole lette, ordinate lessicograficamente con qsort :\n");
	for(i = 0; i < n;i++)
		printf("%d) %s\n",i+1,words[i]);
	printf("Fine dell'elenco.\n");

	qsort(words,n,sizeof(char *),comparelen);

	printf("Elenco delle parole lette, ordinate per lunnghezza con qsort :\n");
	for(i = 0; i < n;i++) {
		printf("%d) %s\n",i+1,words[i]);
		free(words[i]);
	}
	free(words);
	printf("Fine dell'elenco.\n");

	qsort(array,10,sizeof(int),lessthan);

	printf("Array di interi ordinato con qsort :\n");
	for(i = 0; i < 10;i++)
		printf("%d,",array[i]);
	putchar('\n');

	return 0;
}

