#include <stdio.h>
#include <stdlib.h>

typedef int key;

struct searchtree {
	key v;
	struct searchtree *left, *right, *up;
}; 

typedef struct searchtree searchtree;

searchtree *createsearchtree(void);

void inorder(searchtree *p, void (*op)(searchtree *));

searchtree *search(searchtree *p, key k);

searchtree *search2ndvers(searchtree *p, key k);

searchtree *search3rdvers(searchtree *p, key k);

searchtree *itsearch(searchtree *p, key k);

searchtree *treemin(searchtree *p); /* si assume p != NULL */

searchtree *treemax(searchtree *p); /* si assume p != NULL */

searchtree *treesucc(searchtree *q); /* si assume q != NULL */

searchtree *treepred(searchtree *q); /* si assume q != NULL */

searchtree *insert(searchtree *p, key k);

searchtree *delete(searchtree *p, searchtree *q); /* si assume q != NULL */

void destroysearchtree(searchtree *p); /* si assume p != NULL */

